Status: Closed Start date: 09/15/2017

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 3.0   

Description

Subtasks:

Task # 2066: Get basic handler working Closed

Task # 2067: Assign handler a capability Rejected

Task # 2068: Migrate in functions from controller Closed

Task # 2069: Change front-end calls to handler Closed

Task # 2070: Remove controller Closed

Task # 2071: Sourcetype the REST handler logs Closed

Task # 2072: Create config settings to support SHC Closed

Associated revisions

Revision 346 - 09/18/2017 05:41 AM - lukemurphey

Initial version of REST handler

Reference #2048

Revision 349 - 09/18/2017 06:19 PM - lukemurphey

Adding support for retrieving lookup backups from the REST handler

Reference #2048

Revision 353 - 10/05/2017 07:33 AM - lukemurphey

Migrating save to the REST handler

Reference #2048

Revision 354 - 10/05/2017 07:49 AM - lukemurphey

Fixing issue where backups were not being persisted

Reference #2048

Revision 355 - 10/06/2017 06:14 AM - lukemurphey

Consolidated the save functionality into the shared library

Reference #2048
History

#1 - 09/06/2017 05:04 PM - Luke Murphey

- File lookup_editor.tgz added

#2 - 09/07/2017 08:18 PM - Luke Murphey

Wondering if I could just whitelist the files:

http://docs.splunk.com/Documentation/Splunk/6.6.3/Admin/Distsearchconf#REPLICATION_WHITELIST_OPTIONS

#3 - 09/07/2017 09:41 PM - Luke Murphey

The files are being stored in /etc/apps/lookup_editor/lookup_file_backups

#4 - 09/07/2017 09:51 PM - Luke Murphey

I could handle this by using allowRestReplay from https://docs.splunk.com/Documentation/Splunk/6.6.3/Admin/Restmapconf:

allowRestReplay=[true|false]

* POST/PUT/DELETE requests can be replayed on other nodes in the deployment.

* This enables centralized management.

* Turn on or off this feature. You can also control replay at each endpoint

  level. This feature is currently INTERNAL and should not be turned on witout

  consulting splunk support.

* Defaults to false

#5 - 09/07/2017 09:53 PM - Luke Murphey

This is available on 6.3.0+ per https://docs.splunk.com/Documentation/Splunk/6.3.0/Admin/restmapconf.

#6 - 09/15/2017 04:41 AM - Luke Murphey

https://github.com/jrervin/splunk-rest-examples

#7 - 09/15/2017 04:52 AM - Luke Murphey

APIs that need to be converted:

1. get_lookup_info: Get information about a lookup file (owner, size, etc.)

2. get_lookup_backups_list: Get a list of the lookup file backups rendered as JSON.

3. save: save the JSON contents to the lookup file (this is the only one that must be converted to support replication)

4. get_original_lookup_file: provides the lookup file in a way to be downloaded by the browser.

5. get_lookup_contents: Provides the contents of a lookup file as JSON.

#8 - 09/15/2017 05:53 AM - Luke Murphey

This code could use some breaking up (not including the public functions above):

Backups

get_backup_files (getBackupFiles)

get_backup_directory (getBackupDirectory)

backup_lookup_file (backupLookupFile)
Shortcuts

append_if_not_none

flatten_dict

make_lookup_filename (makeLookupFilename)

is_lookup_in_users_path (isLookupInUsersPath)

convert_array_to_csv

escape_filename (escapeFilename)

is_file_name_valid

Lookup

force_lookup_replication

getCapabilities4User

resolve_lookup_filename

get_kv_lookup

get_lookup (signature changed)

Controller specific

render_error_json

#9 - 09/15/2017 07:43 AM - Luke Murphey

backup_lookup_file: function signature has changed (moved resolved_file_path)

#10 - 09/19/2017 07:42 AM - Luke Murphey

I think I will need to break out the backups handler from the main handler so that allowRestReplay can be enabled only for backups.

#11 - 10/05/2017 07:35 AM - Luke Murphey

Some things left to do:

Get backups to work

Clean up post_lookup_contents() which currently does too much and has to call lookupfiles directly

#12 - 10/07/2017 06:25 AM - Luke Murphey

- Status changed from New to Closed

Files

lookup_editor.tgz 336 KB 09/06/2017 Luke Murphey
